/*
 * Read-Copy Update "sched" read-side-primitive performance test module.
 * This is the nested case.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Copyright (C) IBM Corporation, 2007
 *
 * Authors: Paul E. McKenney <paulmck@us.ibm.com>
 */

/* By convention, the name of this source file without extension. */

#define PERFMODULE_NAME "schedreadperfnest"

/* Place any static data (e.g., locks) needed for your test here. */

#define STATIC_DATA

/* Place the operations that your test is to execute here. */

#define PERF_TEST_OP_PRE do { preempt_disable(); } while (0)
#define PERF_TEST_OP do { preempt_disable(); preempt_enable(); } while (0)
#define PERF_TEST_OP_POST do { preempt_enable(); } while (0)

/*
 * CSCOUNT_SCALE is the number of times through the inner loop.  It
 * should be small enough to avoid quantization error, but large enough
 * to amortize loop-termination-check overhead down to insignficant
 * levels.  Best if CSCOUNT_SCALE passes through the inner loop takes
 * at least 100 microseconds, but no more than 1% of the test_duration
 * time.  Yes, this number should really be determined dynamically.
 */

#define CSCOUNT_SCALE (100 * 1024)

#include "perfmeas.h"
